﻿<html>
<?php
	$back = "";
	if( $_GET[ "back" ] != "" ){
		$back = $_GET[ "back" ];
	}
	$id = 0;
	if( $_GET[ "id" ] != "" ){
		$id = $_GET[ "id" ];
	}
?>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>メイン画面</title>
</head>
<script lang="text/javascript">
<!--

// 字幕それぞれ。

var Caption = function( id, opt ){
	var option = opt;
	if( !opt ){
		option = {};
	}
	this.id = id;
	this.step = option.step ? option.step : 12;
	this.pos = Number.POSITIVE_INFINITY;
	this.run = false;

	this.init();
}

Caption.prototype = {
	init : function() {
		var elm = document.getElementById( this.id );
		elm.style.overflow = 'hidden';

		var child = document.createElement( 'div' );
		child.style.margin = '0';
		child.style.padding = '0';
		child.style.background = 'transparent';
		child.style.border = 'none';

		elm.normalize();
		while( elm.firstChild ){
			child.appendChild( elm.removeChild( elm.firstChild ) );
		}

		elm.appendChild( child );

		child.style.position = 'absolute';

		this.curWidth = Math.min( elm.offsetWidth, elm.parentNode.offsetWidth );
		this.minWidth = this.curWidth;

		child.style.position = 'relative';

		this.pos = this.startPosition();
		child.style.left = this.pos + 'px';
	},
	set : function( str ) {
		var elm = document.getElementById( this.id );
		var child = elm.firstChild;

		child.innerHTML = str;

		this.curWidth = Math.min( elm.offsetWidth, elm.parentNode.offsetWidth );
		this.minWidth = this.getWidth( str );

		this.pos = this.startPosition();
		child.style.left = this.pos + 'px';
		this.run = true;
	},
	next: function() {
		if( ! this.run ){
			return;
		}
	
		var elm = document.getElementById( this.id );

		this.curWidth = Math.min( elm.offsetWidth, elm.parentNode.offsetWidth );

		this.pos -= this.step;

		var child = elm.firstChild;

		child.style.left = this.pos + 'px';

		if( this.pos < -this.minWidth ){
			this.run = false;
			return;
		}
		
	},
	startPosition : function(){
		return this.curWidth;
	},
	isOutOfRange : function(){
		return ( this.pos < -this.minWidth || this.curWidth < this.pos );
	},
	getWidth: function( str ) {
		var e = document.getElementById( "ruler" );
		var c;
		while( c = e.lastChild ) e.removeChild( c );
		var text = e.appendChild( document.createTextNode(str) );
		var width = e.offsetWidth;
		e.removeChild( text );
		return width;
	},
}

// マネージャクラス

var Manager = function( ids, opt ){
	this.ids = ids;
	this.delay = 100;
	this.cap = new Array();
	this.mesg = new Array();

	this.sending = 0;
	this.msg_id = <?php echo( $id );?>;

	this.ok = { mark: "ok_mark", count: 0, step: 0 };
	this.ng = { mark: "ng_mark", count: 0, step: 0 };

	for( i in ids ){
		for( j in ids[ i ] ){
			id = ids[ i ][ j ];
			this.cap[ id ] = new Caption( id, opt );
		}
	}
	this.init();
}

Manager.prototype = {
	init : function(){
		for( var i in this.ids ){
			for( var j in this.ids[ i ] ){
				var id = this.ids[ i ][ j ];
				this.cap[ id ].init();
			}
		}

		this.timer_id = window.setInterval( function( self ){ self.next(); }, this.delay, this );
	},
	next : function() {
		// 読み込み処理
		if( this.sending > 0 ){
			this.sending --;
		}
		if( this.sending == 0 ){
			var req = new XMLHttpRequest();
			var self = this;

			req.open( 'GET', "get.php?id="+this.msg_id, true );
			req.onreadystatechange = function( aEvt ){
				if( req.readyState == 4 ){
					if( req.status == 200 ){
						self.parse( req.responseText );
					}
					self.sending = 10;
				}
			}
			req.send( null );
			this.sending = -1;
		}

		// スクロール処理
		for( var i in this.ids ){
			var ng_flag = false;
			var empty = -1;
			for( var j in this.ids[ i ] ){
				var id = this.ids[ i ][ j ];

				var cap = this.cap[ id ];

				cap.next();
				if( cap.run ){
					if( cap.pos + cap.minWidth > cap.curWidth - 50 ){
						ng_flag = true;
					}
				} else {
					empty = j;
				}
			}
			if( this.mesg.length > 0 && ! ng_flag && empty != -1 ){
				var str = this.mesg.shift();
				var id = this.ids[ i ][ empty ];
				this.cap[ id ].set( str );
			}
		}

		var mids = [ this.ok, this.ng ];
		for( var i = 0; i < mids.length; i++ ){
			var id = mids[ i ];
			if( id.step > 0 ){
				var e = document.getElementById( id.mark );
				var r = ( id.count * 64 );
				if( r > 255 ){
					r = 255;
				}
				var rt = ( "0"+r.toString( 16 ) ).slice( -2 );
				e.style.color = "#"+rt+"0000";
				if( id.step > 2 ){
					e.style.fontStyle = "normal";
				} else {
					e.style.fontStyle = "italic";
				}
				id.step--;
			} else if( id.count > 0 ){
				id.step = 6;
				id.count--;
			}
		}
	},
	set : function( str, t ) {
		this.mesg.push( str );
	},
	parse : function( str ){
		var res = eval( '('+ str + ')' );
		for( var i in res.data ){
			if( this.msg_id < res.data[ i ].id ){
				this.msg_id = res.data[ i ].id;
			}
			var msg = res.data[ i ].message;

			if( msg == "__OK__" ){
				this.ok.count ++;
			} else if( msg == "__NG__" ){
				this.ng.count ++;
			} else {
				this.set( msg );
			}
		}
	}
}

// -->
</script>
<style type="text/css">
<!--
.mq {
	font-size:36px;
	font-weight: bold;
}

.mark {
	position: absolute;
	font-size: 48px;
	font-style: italic;
	font-weight: bold;
}

.pzimage {
	position: absolute;
	z-index: -1;
	margin: 0px;
	padding: 0px;
	top: 0px;
	left: 0px;
	width: 100%;
	height: 100%;
}

-->
</style>

<body>

<image class="pzimage" id="pzimg" src="<?php echo($back)?>">

<div class="mark" id="ok_mark" style="top: 48px;right: 56px;">
&nbsp;!&nbsp;
</div>
<div class="mark" id="ng_mark" style="top: 48px;right: 8px;">
&nbsp;?&nbsp;
</div>

<?php
define( "PER_LINE_MAX", 5 );
define( "LINE_MAX", 4 );

$posy = array( 500, 460, 420, 540 );

for( $i = 0; $i < LINE_MAX; $i++ ){
	print <<< EOT
	<div class="mq" style="width:100%;position:absolute;top:{$posy[$i]}px;">
EOT;
	for( $j = 0; $j < PER_LINE_MAX; $j++ ){
		print <<< EOT
		<div style="position:absolute;width:100%;">
			<div class="mq" id="m{$i}{$j}" style="width:auto;"></div>
		</div>
EOT;
	}
	print <<< EOT
	</div>
EOT;
}
?>

<span class="mq" id="ruler" style="visibility:hidden;position:absolute;"></span>

<script type="text/javascript">
var ids = [
<?php
for( $i = 0; $i < LINE_MAX; $i++ ){
	print "[ ";
	for( $j = 0; $j < PER_LINE_MAX; $j++ ){
		print "\"m{$i}{$j}\"," ;
	}
	print "],";
}
?>
			];

var man = new Manager( ids );

</script>

</body>
</html>
